--
-- $Id$
--
-- Gebouwen lijst inlezen en email, kostenplaats en kenmerk via script aanpassen.

DEFINE thisfile = 'RABO#55951.SQL'
DEFINE dbuser   = '^RABO'

SET ECHO ON
SET DEFINE ON
COLUMN fcltlogfile NEW_VALUE fcltlogfile NOPRINT;
WHENEVER SQLERROR EXIT;
SELECT adm.scriptspoolfile('&dbuser', '&thisfile') AS fcltlogfile FROM DUAL;
WHENEVER SQLERROR CONTINUE;
SPOOL &fcltlogfile
SET DEFINE OFF

------ payload begin ------


DECLARE
    CURSOR c
    IS
        SELECT g.alg_gebouw_key, i.*
          FROM alg_gebouw g, fac_imp_onrgoed1 i
         WHERE g.alg_gebouw_code = i.alg_gebouw_code;

    v_import_key         NUMBER;
    v_error              VARCHAR2 (1000);
    v_kostenplaats_key   NUMBER;
BEGIN
    SELECT MAX (fac_import_key)
      INTO v_import_key
      FROM fac_import
     WHERE fac_import_app_key = 1;                                 -- ONRGOED1

    FOR rec IN C
    LOOP
        BEGIN
            v_error := 'Opslaan Aanmeldinstructie';
            ALG.upsertkenmerk (
                1143,
                rec.alg_gebouw_key,
                   'Voor aanvang werkzaamheden dient u zich aan te melden voor de betreffende locatie. Stuur een mail naar servicedeskrabobank@heydayfm.nl met de volgende gegevens: naam monteur, locatie, datum, aanvangstijd, opdrachtnummer uit Facilitor. '
                || CHR (10)
                || 'Indien u toegang dient te verkrijgen voor een OLGA dan verzoeken we u om ook het telefoonnummer en email adres van de contactpersoon aan te leveren. ');

            v_error := 'Opzoeken kostenplaats';

            SELECT prs_kostenplaats_key
              INTO v_kostenplaats_key
              FROM prs_kostenplaats
             WHERE prs_kostenplaats_nr =
                   SUBSTR (rec.alg_kenmerkwaarde2,
                           1,
                           INSTR (rec.alg_kenmerkwaarde2, ' ') - 1);

            v_error := 'Aanpassen gebouw';

            UPDATE alg_gebouw
               SET prs_kostenplaats_key = v_kostenplaats_key,
                   alg_gebouw_email = rec.alg_kenmerkwaarde1
             WHERE alg_gebouw_key = rec.alg_gebouw_key;
        EXCEPTION
            WHEN OTHERS
            THEN
                fac.imp_writelog (
                    v_import_key,
                    'E',
                    v_error,
                       rec.alg_gebouw_key
                    || ' - '
                    || rec.alg_kenmerkwaarde1
                    || ' - '
                    || rec.alg_kenmerkwaarde2);
        END;
    END LOOP;

    COMMIT;
END;
/

------ payload end   ------

SET DEFINE OFF
BEGIN adm.systrackscriptId ('$Id$', 1); END;
/

COMMIT;
SET ECHO OFF
SPOOL OFF
SET DEFINE ON
PROMPT Logfile of this upgrade is: &fcltlogfile